// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: cosmos/upgrade/v1beta1/upgrade.proto

package cosmos.upgrade.v1beta1;

public final class Upgrade {
  private Upgrade() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface PlanOrBuilder extends
      // @@protoc_insertion_point(interface_extends:cosmos.upgrade.v1beta1.Plan)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * Sets the name for the upgrade. This name will be used by the upgraded
     * version of the software to apply any special "on-upgrade" commands during
     * the first BeginBlock method after the upgrade is applied. It is also used
     * to detect whether a software version can handle a given upgrade. If no
     * upgrade handler with this name has been set in the software, it will be
     * assumed that the software is out-of-date when the upgrade Time or Height is
     * reached and the software will exit.
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The name.
     */
    java.lang.String getName();
    /**
     * <pre>
     * Sets the name for the upgrade. This name will be used by the upgraded
     * version of the software to apply any special "on-upgrade" commands during
     * the first BeginBlock method after the upgrade is applied. It is also used
     * to detect whether a software version can handle a given upgrade. If no
     * upgrade handler with this name has been set in the software, it will be
     * assumed that the software is out-of-date when the upgrade Time or Height is
     * reached and the software will exit.
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The bytes for name.
     */
    com.google.protobuf.ByteString
        getNameBytes();

    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     * @return Whether the time field is set.
     */
    boolean hasTime();
    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     * @return The time.
     */
    com.google.protobuf.Timestamp getTime();
    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     */
    com.google.protobuf.TimestampOrBuilder getTimeOrBuilder();

    /**
     * <pre>
     * The height at which the upgrade must be performed.
     * Only used if Time is not set.
     * </pre>
     *
     * <code>int64 height = 3;</code>
     * @return The height.
     */
    long getHeight();

    /**
     * <pre>
     * Any application specific upgrade info to be included on-chain
     * such as a git commit that validators could automatically upgrade to
     * </pre>
     *
     * <code>string info = 4;</code>
     * @return The info.
     */
    java.lang.String getInfo();
    /**
     * <pre>
     * Any application specific upgrade info to be included on-chain
     * such as a git commit that validators could automatically upgrade to
     * </pre>
     *
     * <code>string info = 4;</code>
     * @return The bytes for info.
     */
    com.google.protobuf.ByteString
        getInfoBytes();

    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     * @return Whether the upgradedClientState field is set.
     */
    boolean hasUpgradedClientState();
    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     * @return The upgradedClientState.
     */
    com.google.protobuf2.Any getUpgradedClientState();
    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     */
    com.google.protobuf2.AnyOrBuilder getUpgradedClientStateOrBuilder();
  }
  /**
   * <pre>
   * Plan specifies information about a planned upgrade and when it should occur.
   * </pre>
   *
   * Protobuf type {@code cosmos.upgrade.v1beta1.Plan}
   */
  public static final class Plan extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:cosmos.upgrade.v1beta1.Plan)
      PlanOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Plan.newBuilder() to construct.
    private Plan(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Plan() {
      name_ = "";
      info_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Plan();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Plan(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              java.lang.String s = input.readStringRequireUtf8();

              name_ = s;
              break;
            }
            case 18: {
              com.google.protobuf.Timestamp.Builder subBuilder = null;
              if (time_ != null) {
                subBuilder = time_.toBuilder();
              }
              time_ = input.readMessage(com.google.protobuf.Timestamp.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(time_);
                time_ = subBuilder.buildPartial();
              }

              break;
            }
            case 24: {

              height_ = input.readInt64();
              break;
            }
            case 34: {
              java.lang.String s = input.readStringRequireUtf8();

              info_ = s;
              break;
            }
            case 42: {
              com.google.protobuf2.Any.Builder subBuilder = null;
              if (upgradedClientState_ != null) {
                subBuilder = upgradedClientState_.toBuilder();
              }
              upgradedClientState_ = input.readMessage(com.google.protobuf2.Any.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(upgradedClientState_);
                upgradedClientState_ = subBuilder.buildPartial();
              }

              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_Plan_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_Plan_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              cosmos.upgrade.v1beta1.Upgrade.Plan.class, cosmos.upgrade.v1beta1.Upgrade.Plan.Builder.class);
    }

    public static final int NAME_FIELD_NUMBER = 1;
    private volatile java.lang.Object name_;
    /**
     * <pre>
     * Sets the name for the upgrade. This name will be used by the upgraded
     * version of the software to apply any special "on-upgrade" commands during
     * the first BeginBlock method after the upgrade is applied. It is also used
     * to detect whether a software version can handle a given upgrade. If no
     * upgrade handler with this name has been set in the software, it will be
     * assumed that the software is out-of-date when the upgrade Time or Height is
     * reached and the software will exit.
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The name.
     */
    @java.lang.Override
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * Sets the name for the upgrade. This name will be used by the upgraded
     * version of the software to apply any special "on-upgrade" commands during
     * the first BeginBlock method after the upgrade is applied. It is also used
     * to detect whether a software version can handle a given upgrade. If no
     * upgrade handler with this name has been set in the software, it will be
     * assumed that the software is out-of-date when the upgrade Time or Height is
     * reached and the software will exit.
     * </pre>
     *
     * <code>string name = 1;</code>
     * @return The bytes for name.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int TIME_FIELD_NUMBER = 2;
    private com.google.protobuf.Timestamp time_;
    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     * @return Whether the time field is set.
     */
    @java.lang.Override
    public boolean hasTime() {
      return time_ != null;
    }
    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     * @return The time.
     */
    @java.lang.Override
    public com.google.protobuf.Timestamp getTime() {
      return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
    }
    /**
     * <pre>
     * The time after which the upgrade must be performed.
     * Leave set to its zero value to use a pre-defined Height instead.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
     */
    @java.lang.Override
    public com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
      return getTime();
    }

    public static final int HEIGHT_FIELD_NUMBER = 3;
    private long height_;
    /**
     * <pre>
     * The height at which the upgrade must be performed.
     * Only used if Time is not set.
     * </pre>
     *
     * <code>int64 height = 3;</code>
     * @return The height.
     */
    @java.lang.Override
    public long getHeight() {
      return height_;
    }

    public static final int INFO_FIELD_NUMBER = 4;
    private volatile java.lang.Object info_;
    /**
     * <pre>
     * Any application specific upgrade info to be included on-chain
     * such as a git commit that validators could automatically upgrade to
     * </pre>
     *
     * <code>string info = 4;</code>
     * @return The info.
     */
    @java.lang.Override
    public java.lang.String getInfo() {
      java.lang.Object ref = info_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        info_ = s;
        return s;
      }
    }
    /**
     * <pre>
     * Any application specific upgrade info to be included on-chain
     * such as a git commit that validators could automatically upgrade to
     * </pre>
     *
     * <code>string info = 4;</code>
     * @return The bytes for info.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getInfoBytes() {
      java.lang.Object ref = info_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        info_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int UPGRADED_CLIENT_STATE_FIELD_NUMBER = 5;
    private com.google.protobuf2.Any upgradedClientState_;
    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     * @return Whether the upgradedClientState field is set.
     */
    @java.lang.Override
    public boolean hasUpgradedClientState() {
      return upgradedClientState_ != null;
    }
    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     * @return The upgradedClientState.
     */
    @java.lang.Override
    public com.google.protobuf2.Any getUpgradedClientState() {
      return upgradedClientState_ == null ? com.google.protobuf2.Any.getDefaultInstance() : upgradedClientState_;
    }
    /**
     * <pre>
     * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
     * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
     * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
     * previous version of the chain.
     * This will allow IBC connections to persist smoothly across planned chain upgrades
     * </pre>
     *
     * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
     */
    @java.lang.Override
    public com.google.protobuf2.AnyOrBuilder getUpgradedClientStateOrBuilder() {
      return getUpgradedClientState();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!getNameBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, name_);
      }
      if (time_ != null) {
        output.writeMessage(2, getTime());
      }
      if (height_ != 0L) {
        output.writeInt64(3, height_);
      }
      if (!getInfoBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 4, info_);
      }
      if (upgradedClientState_ != null) {
        output.writeMessage(5, getUpgradedClientState());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getNameBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, name_);
      }
      if (time_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(2, getTime());
      }
      if (height_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(3, height_);
      }
      if (!getInfoBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, info_);
      }
      if (upgradedClientState_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(5, getUpgradedClientState());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof cosmos.upgrade.v1beta1.Upgrade.Plan)) {
        return super.equals(obj);
      }
      cosmos.upgrade.v1beta1.Upgrade.Plan other = (cosmos.upgrade.v1beta1.Upgrade.Plan) obj;

      if (!getName()
          .equals(other.getName())) return false;
      if (hasTime() != other.hasTime()) return false;
      if (hasTime()) {
        if (!getTime()
            .equals(other.getTime())) return false;
      }
      if (getHeight()
          != other.getHeight()) return false;
      if (!getInfo()
          .equals(other.getInfo())) return false;
      if (hasUpgradedClientState() != other.hasUpgradedClientState()) return false;
      if (hasUpgradedClientState()) {
        if (!getUpgradedClientState()
            .equals(other.getUpgradedClientState())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + NAME_FIELD_NUMBER;
      hash = (53 * hash) + getName().hashCode();
      if (hasTime()) {
        hash = (37 * hash) + TIME_FIELD_NUMBER;
        hash = (53 * hash) + getTime().hashCode();
      }
      hash = (37 * hash) + HEIGHT_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getHeight());
      hash = (37 * hash) + INFO_FIELD_NUMBER;
      hash = (53 * hash) + getInfo().hashCode();
      if (hasUpgradedClientState()) {
        hash = (37 * hash) + UPGRADED_CLIENT_STATE_FIELD_NUMBER;
        hash = (53 * hash) + getUpgradedClientState().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.Plan parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(cosmos.upgrade.v1beta1.Upgrade.Plan prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * Plan specifies information about a planned upgrade and when it should occur.
     * </pre>
     *
     * Protobuf type {@code cosmos.upgrade.v1beta1.Plan}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:cosmos.upgrade.v1beta1.Plan)
        cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_Plan_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_Plan_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                cosmos.upgrade.v1beta1.Upgrade.Plan.class, cosmos.upgrade.v1beta1.Upgrade.Plan.Builder.class);
      }

      // Construct using cosmos.upgrade.v1beta1.Upgrade.Plan.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        name_ = "";

        if (timeBuilder_ == null) {
          time_ = null;
        } else {
          time_ = null;
          timeBuilder_ = null;
        }
        height_ = 0L;

        info_ = "";

        if (upgradedClientStateBuilder_ == null) {
          upgradedClientState_ = null;
        } else {
          upgradedClientState_ = null;
          upgradedClientStateBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_Plan_descriptor;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.Plan getDefaultInstanceForType() {
        return cosmos.upgrade.v1beta1.Upgrade.Plan.getDefaultInstance();
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.Plan build() {
        cosmos.upgrade.v1beta1.Upgrade.Plan result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.Plan buildPartial() {
        cosmos.upgrade.v1beta1.Upgrade.Plan result = new cosmos.upgrade.v1beta1.Upgrade.Plan(this);
        result.name_ = name_;
        if (timeBuilder_ == null) {
          result.time_ = time_;
        } else {
          result.time_ = timeBuilder_.build();
        }
        result.height_ = height_;
        result.info_ = info_;
        if (upgradedClientStateBuilder_ == null) {
          result.upgradedClientState_ = upgradedClientState_;
        } else {
          result.upgradedClientState_ = upgradedClientStateBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof cosmos.upgrade.v1beta1.Upgrade.Plan) {
          return mergeFrom((cosmos.upgrade.v1beta1.Upgrade.Plan)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(cosmos.upgrade.v1beta1.Upgrade.Plan other) {
        if (other == cosmos.upgrade.v1beta1.Upgrade.Plan.getDefaultInstance()) return this;
        if (!other.getName().isEmpty()) {
          name_ = other.name_;
          onChanged();
        }
        if (other.hasTime()) {
          mergeTime(other.getTime());
        }
        if (other.getHeight() != 0L) {
          setHeight(other.getHeight());
        }
        if (!other.getInfo().isEmpty()) {
          info_ = other.info_;
          onChanged();
        }
        if (other.hasUpgradedClientState()) {
          mergeUpgradedClientState(other.getUpgradedClientState());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        cosmos.upgrade.v1beta1.Upgrade.Plan parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (cosmos.upgrade.v1beta1.Upgrade.Plan) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object name_ = "";
      /**
       * <pre>
       * Sets the name for the upgrade. This name will be used by the upgraded
       * version of the software to apply any special "on-upgrade" commands during
       * the first BeginBlock method after the upgrade is applied. It is also used
       * to detect whether a software version can handle a given upgrade. If no
       * upgrade handler with this name has been set in the software, it will be
       * assumed that the software is out-of-date when the upgrade Time or Height is
       * reached and the software will exit.
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return The name.
       */
      public java.lang.String getName() {
        java.lang.Object ref = name_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          name_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * Sets the name for the upgrade. This name will be used by the upgraded
       * version of the software to apply any special "on-upgrade" commands during
       * the first BeginBlock method after the upgrade is applied. It is also used
       * to detect whether a software version can handle a given upgrade. If no
       * upgrade handler with this name has been set in the software, it will be
       * assumed that the software is out-of-date when the upgrade Time or Height is
       * reached and the software will exit.
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return The bytes for name.
       */
      public com.google.protobuf.ByteString
          getNameBytes() {
        java.lang.Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          name_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * Sets the name for the upgrade. This name will be used by the upgraded
       * version of the software to apply any special "on-upgrade" commands during
       * the first BeginBlock method after the upgrade is applied. It is also used
       * to detect whether a software version can handle a given upgrade. If no
       * upgrade handler with this name has been set in the software, it will be
       * assumed that the software is out-of-date when the upgrade Time or Height is
       * reached and the software will exit.
       * </pre>
       *
       * <code>string name = 1;</code>
       * @param value The name to set.
       * @return This builder for chaining.
       */
      public Builder setName(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        name_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Sets the name for the upgrade. This name will be used by the upgraded
       * version of the software to apply any special "on-upgrade" commands during
       * the first BeginBlock method after the upgrade is applied. It is also used
       * to detect whether a software version can handle a given upgrade. If no
       * upgrade handler with this name has been set in the software, it will be
       * assumed that the software is out-of-date when the upgrade Time or Height is
       * reached and the software will exit.
       * </pre>
       *
       * <code>string name = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearName() {
        
        name_ = getDefaultInstance().getName();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Sets the name for the upgrade. This name will be used by the upgraded
       * version of the software to apply any special "on-upgrade" commands during
       * the first BeginBlock method after the upgrade is applied. It is also used
       * to detect whether a software version can handle a given upgrade. If no
       * upgrade handler with this name has been set in the software, it will be
       * assumed that the software is out-of-date when the upgrade Time or Height is
       * reached and the software will exit.
       * </pre>
       *
       * <code>string name = 1;</code>
       * @param value The bytes for name to set.
       * @return This builder for chaining.
       */
      public Builder setNameBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        name_ = value;
        onChanged();
        return this;
      }

      private com.google.protobuf.Timestamp time_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.protobuf.Timestamp, com.google.protobuf.Timestamp.Builder, com.google.protobuf.TimestampOrBuilder> timeBuilder_;
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       * @return Whether the time field is set.
       */
      public boolean hasTime() {
        return timeBuilder_ != null || time_ != null;
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       * @return The time.
       */
      public com.google.protobuf.Timestamp getTime() {
        if (timeBuilder_ == null) {
          return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        } else {
          return timeBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public Builder setTime(com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          time_ = value;
          onChanged();
        } else {
          timeBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public Builder setTime(
          com.google.protobuf.Timestamp.Builder builderForValue) {
        if (timeBuilder_ == null) {
          time_ = builderForValue.build();
          onChanged();
        } else {
          timeBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public Builder mergeTime(com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (time_ != null) {
            time_ =
              com.google.protobuf.Timestamp.newBuilder(time_).mergeFrom(value).buildPartial();
          } else {
            time_ = value;
          }
          onChanged();
        } else {
          timeBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public Builder clearTime() {
        if (timeBuilder_ == null) {
          time_ = null;
          onChanged();
        } else {
          time_ = null;
          timeBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public com.google.protobuf.Timestamp.Builder getTimeBuilder() {
        
        onChanged();
        return getTimeFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      public com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
        if (timeBuilder_ != null) {
          return timeBuilder_.getMessageOrBuilder();
        } else {
          return time_ == null ?
              com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        }
      }
      /**
       * <pre>
       * The time after which the upgrade must be performed.
       * Leave set to its zero value to use a pre-defined Height instead.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 2 [(.gogoproto.nullable) = false, (.gogoproto.stdtime) = true];</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.protobuf.Timestamp, com.google.protobuf.Timestamp.Builder, com.google.protobuf.TimestampOrBuilder> 
          getTimeFieldBuilder() {
        if (timeBuilder_ == null) {
          timeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp, com.google.protobuf.Timestamp.Builder, com.google.protobuf.TimestampOrBuilder>(
                  getTime(),
                  getParentForChildren(),
                  isClean());
          time_ = null;
        }
        return timeBuilder_;
      }

      private long height_ ;
      /**
       * <pre>
       * The height at which the upgrade must be performed.
       * Only used if Time is not set.
       * </pre>
       *
       * <code>int64 height = 3;</code>
       * @return The height.
       */
      @java.lang.Override
      public long getHeight() {
        return height_;
      }
      /**
       * <pre>
       * The height at which the upgrade must be performed.
       * Only used if Time is not set.
       * </pre>
       *
       * <code>int64 height = 3;</code>
       * @param value The height to set.
       * @return This builder for chaining.
       */
      public Builder setHeight(long value) {
        
        height_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The height at which the upgrade must be performed.
       * Only used if Time is not set.
       * </pre>
       *
       * <code>int64 height = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearHeight() {
        
        height_ = 0L;
        onChanged();
        return this;
      }

      private java.lang.Object info_ = "";
      /**
       * <pre>
       * Any application specific upgrade info to be included on-chain
       * such as a git commit that validators could automatically upgrade to
       * </pre>
       *
       * <code>string info = 4;</code>
       * @return The info.
       */
      public java.lang.String getInfo() {
        java.lang.Object ref = info_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          info_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <pre>
       * Any application specific upgrade info to be included on-chain
       * such as a git commit that validators could automatically upgrade to
       * </pre>
       *
       * <code>string info = 4;</code>
       * @return The bytes for info.
       */
      public com.google.protobuf.ByteString
          getInfoBytes() {
        java.lang.Object ref = info_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          info_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <pre>
       * Any application specific upgrade info to be included on-chain
       * such as a git commit that validators could automatically upgrade to
       * </pre>
       *
       * <code>string info = 4;</code>
       * @param value The info to set.
       * @return This builder for chaining.
       */
      public Builder setInfo(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        info_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Any application specific upgrade info to be included on-chain
       * such as a git commit that validators could automatically upgrade to
       * </pre>
       *
       * <code>string info = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearInfo() {
        
        info_ = getDefaultInstance().getInfo();
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Any application specific upgrade info to be included on-chain
       * such as a git commit that validators could automatically upgrade to
       * </pre>
       *
       * <code>string info = 4;</code>
       * @param value The bytes for info to set.
       * @return This builder for chaining.
       */
      public Builder setInfoBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        info_ = value;
        onChanged();
        return this;
      }

      private com.google.protobuf2.Any upgradedClientState_;
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.protobuf2.Any, com.google.protobuf2.Any.Builder, com.google.protobuf2.AnyOrBuilder> upgradedClientStateBuilder_;
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       * @return Whether the upgradedClientState field is set.
       */
      public boolean hasUpgradedClientState() {
        return upgradedClientStateBuilder_ != null || upgradedClientState_ != null;
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       * @return The upgradedClientState.
       */
      public com.google.protobuf2.Any getUpgradedClientState() {
        if (upgradedClientStateBuilder_ == null) {
          return upgradedClientState_ == null ? com.google.protobuf2.Any.getDefaultInstance() : upgradedClientState_;
        } else {
          return upgradedClientStateBuilder_.getMessage();
        }
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public Builder setUpgradedClientState(com.google.protobuf2.Any value) {
        if (upgradedClientStateBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          upgradedClientState_ = value;
          onChanged();
        } else {
          upgradedClientStateBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public Builder setUpgradedClientState(
          com.google.protobuf2.Any.Builder builderForValue) {
        if (upgradedClientStateBuilder_ == null) {
          upgradedClientState_ = builderForValue.build();
          onChanged();
        } else {
          upgradedClientStateBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public Builder mergeUpgradedClientState(com.google.protobuf2.Any value) {
        if (upgradedClientStateBuilder_ == null) {
          if (upgradedClientState_ != null) {
            upgradedClientState_ =
              com.google.protobuf2.Any.newBuilder(upgradedClientState_).mergeFrom(value).buildPartial();
          } else {
            upgradedClientState_ = value;
          }
          onChanged();
        } else {
          upgradedClientStateBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public Builder clearUpgradedClientState() {
        if (upgradedClientStateBuilder_ == null) {
          upgradedClientState_ = null;
          onChanged();
        } else {
          upgradedClientState_ = null;
          upgradedClientStateBuilder_ = null;
        }

        return this;
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public com.google.protobuf2.Any.Builder getUpgradedClientStateBuilder() {
        
        onChanged();
        return getUpgradedClientStateFieldBuilder().getBuilder();
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      public com.google.protobuf2.AnyOrBuilder getUpgradedClientStateOrBuilder() {
        if (upgradedClientStateBuilder_ != null) {
          return upgradedClientStateBuilder_.getMessageOrBuilder();
        } else {
          return upgradedClientState_ == null ?
              com.google.protobuf2.Any.getDefaultInstance() : upgradedClientState_;
        }
      }
      /**
       * <pre>
       * IBC-enabled chains can opt-in to including the upgraded client state in its upgrade plan
       * This will make the chain commit to the correct upgraded (self) client state before the upgrade occurs,
       * so that connecting chains can verify that the new upgraded client is valid by verifying a proof on the
       * previous version of the chain.
       * This will allow IBC connections to persist smoothly across planned chain upgrades
       * </pre>
       *
       * <code>.google.protobuf2.Any upgraded_client_state = 5 [(.gogoproto.moretags) = "yaml:&#92;"upgraded_client_state&#92;""];</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          com.google.protobuf2.Any, com.google.protobuf2.Any.Builder, com.google.protobuf2.AnyOrBuilder> 
          getUpgradedClientStateFieldBuilder() {
        if (upgradedClientStateBuilder_ == null) {
          upgradedClientStateBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf2.Any, com.google.protobuf2.Any.Builder, com.google.protobuf2.AnyOrBuilder>(
                  getUpgradedClientState(),
                  getParentForChildren(),
                  isClean());
          upgradedClientState_ = null;
        }
        return upgradedClientStateBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:cosmos.upgrade.v1beta1.Plan)
    }

    // @@protoc_insertion_point(class_scope:cosmos.upgrade.v1beta1.Plan)
    private static final cosmos.upgrade.v1beta1.Upgrade.Plan DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new cosmos.upgrade.v1beta1.Upgrade.Plan();
    }

    public static cosmos.upgrade.v1beta1.Upgrade.Plan getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Plan>
        PARSER = new com.google.protobuf.AbstractParser<Plan>() {
      @java.lang.Override
      public Plan parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new Plan(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<Plan> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Plan> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public cosmos.upgrade.v1beta1.Upgrade.Plan getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface SoftwareUpgradeProposalOrBuilder extends
      // @@protoc_insertion_point(interface_extends:cosmos.upgrade.v1beta1.SoftwareUpgradeProposal)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>string title = 1;</code>
     * @return The title.
     */
    java.lang.String getTitle();
    /**
     * <code>string title = 1;</code>
     * @return The bytes for title.
     */
    com.google.protobuf.ByteString
        getTitleBytes();

    /**
     * <code>string description = 2;</code>
     * @return The description.
     */
    java.lang.String getDescription();
    /**
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    com.google.protobuf.ByteString
        getDescriptionBytes();

    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     * @return Whether the plan field is set.
     */
    boolean hasPlan();
    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     * @return The plan.
     */
    cosmos.upgrade.v1beta1.Upgrade.Plan getPlan();
    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     */
    cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder getPlanOrBuilder();
  }
  /**
   * <pre>
   * SoftwareUpgradeProposal is a gov Content type for initiating a software
   * upgrade.
   * </pre>
   *
   * Protobuf type {@code cosmos.upgrade.v1beta1.SoftwareUpgradeProposal}
   */
  public static final class SoftwareUpgradeProposal extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:cosmos.upgrade.v1beta1.SoftwareUpgradeProposal)
      SoftwareUpgradeProposalOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use SoftwareUpgradeProposal.newBuilder() to construct.
    private SoftwareUpgradeProposal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private SoftwareUpgradeProposal() {
      title_ = "";
      description_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new SoftwareUpgradeProposal();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private SoftwareUpgradeProposal(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              java.lang.String s = input.readStringRequireUtf8();

              title_ = s;
              break;
            }
            case 18: {
              java.lang.String s = input.readStringRequireUtf8();

              description_ = s;
              break;
            }
            case 26: {
              cosmos.upgrade.v1beta1.Upgrade.Plan.Builder subBuilder = null;
              if (plan_ != null) {
                subBuilder = plan_.toBuilder();
              }
              plan_ = input.readMessage(cosmos.upgrade.v1beta1.Upgrade.Plan.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(plan_);
                plan_ = subBuilder.buildPartial();
              }

              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.class, cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.Builder.class);
    }

    public static final int TITLE_FIELD_NUMBER = 1;
    private volatile java.lang.Object title_;
    /**
     * <code>string title = 1;</code>
     * @return The title.
     */
    @java.lang.Override
    public java.lang.String getTitle() {
      java.lang.Object ref = title_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        title_ = s;
        return s;
      }
    }
    /**
     * <code>string title = 1;</code>
     * @return The bytes for title.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getTitleBytes() {
      java.lang.Object ref = title_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        title_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int DESCRIPTION_FIELD_NUMBER = 2;
    private volatile java.lang.Object description_;
    /**
     * <code>string description = 2;</code>
     * @return The description.
     */
    @java.lang.Override
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      }
    }
    /**
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int PLAN_FIELD_NUMBER = 3;
    private cosmos.upgrade.v1beta1.Upgrade.Plan plan_;
    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     * @return Whether the plan field is set.
     */
    @java.lang.Override
    public boolean hasPlan() {
      return plan_ != null;
    }
    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     * @return The plan.
     */
    @java.lang.Override
    public cosmos.upgrade.v1beta1.Upgrade.Plan getPlan() {
      return plan_ == null ? cosmos.upgrade.v1beta1.Upgrade.Plan.getDefaultInstance() : plan_;
    }
    /**
     * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
     */
    @java.lang.Override
    public cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder getPlanOrBuilder() {
      return getPlan();
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!getTitleBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, title_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, description_);
      }
      if (plan_ != null) {
        output.writeMessage(3, getPlan());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getTitleBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, title_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, description_);
      }
      if (plan_ != null) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(3, getPlan());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal)) {
        return super.equals(obj);
      }
      cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal other = (cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal) obj;

      if (!getTitle()
          .equals(other.getTitle())) return false;
      if (!getDescription()
          .equals(other.getDescription())) return false;
      if (hasPlan() != other.hasPlan()) return false;
      if (hasPlan()) {
        if (!getPlan()
            .equals(other.getPlan())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + TITLE_FIELD_NUMBER;
      hash = (53 * hash) + getTitle().hashCode();
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
      if (hasPlan()) {
        hash = (37 * hash) + PLAN_FIELD_NUMBER;
        hash = (53 * hash) + getPlan().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * SoftwareUpgradeProposal is a gov Content type for initiating a software
     * upgrade.
     * </pre>
     *
     * Protobuf type {@code cosmos.upgrade.v1beta1.SoftwareUpgradeProposal}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:cosmos.upgrade.v1beta1.SoftwareUpgradeProposal)
        cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposalOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.class, cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.Builder.class);
      }

      // Construct using cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        title_ = "";

        description_ = "";

        if (planBuilder_ == null) {
          plan_ = null;
        } else {
          plan_ = null;
          planBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal getDefaultInstanceForType() {
        return cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.getDefaultInstance();
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal build() {
        cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal buildPartial() {
        cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal result = new cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal(this);
        result.title_ = title_;
        result.description_ = description_;
        if (planBuilder_ == null) {
          result.plan_ = plan_;
        } else {
          result.plan_ = planBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal) {
          return mergeFrom((cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal other) {
        if (other == cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal.getDefaultInstance()) return this;
        if (!other.getTitle().isEmpty()) {
          title_ = other.title_;
          onChanged();
        }
        if (!other.getDescription().isEmpty()) {
          description_ = other.description_;
          onChanged();
        }
        if (other.hasPlan()) {
          mergePlan(other.getPlan());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object title_ = "";
      /**
       * <code>string title = 1;</code>
       * @return The title.
       */
      public java.lang.String getTitle() {
        java.lang.Object ref = title_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          title_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string title = 1;</code>
       * @return The bytes for title.
       */
      public com.google.protobuf.ByteString
          getTitleBytes() {
        java.lang.Object ref = title_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          title_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string title = 1;</code>
       * @param value The title to set.
       * @return This builder for chaining.
       */
      public Builder setTitle(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        title_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string title = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearTitle() {
        
        title_ = getDefaultInstance().getTitle();
        onChanged();
        return this;
      }
      /**
       * <code>string title = 1;</code>
       * @param value The bytes for title to set.
       * @return This builder for chaining.
       */
      public Builder setTitleBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        title_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object description_ = "";
      /**
       * <code>string description = 2;</code>
       * @return The description.
       */
      public java.lang.String getDescription() {
        java.lang.Object ref = description_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          description_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string description = 2;</code>
       * @return The bytes for description.
       */
      public com.google.protobuf.ByteString
          getDescriptionBytes() {
        java.lang.Object ref = description_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          description_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string description = 2;</code>
       * @param value The description to set.
       * @return This builder for chaining.
       */
      public Builder setDescription(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        description_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string description = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearDescription() {
        
        description_ = getDefaultInstance().getDescription();
        onChanged();
        return this;
      }
      /**
       * <code>string description = 2;</code>
       * @param value The bytes for description to set.
       * @return This builder for chaining.
       */
      public Builder setDescriptionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        description_ = value;
        onChanged();
        return this;
      }

      private cosmos.upgrade.v1beta1.Upgrade.Plan plan_;
      private com.google.protobuf.SingleFieldBuilderV3<
          cosmos.upgrade.v1beta1.Upgrade.Plan, cosmos.upgrade.v1beta1.Upgrade.Plan.Builder, cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder> planBuilder_;
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       * @return Whether the plan field is set.
       */
      public boolean hasPlan() {
        return planBuilder_ != null || plan_ != null;
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       * @return The plan.
       */
      public cosmos.upgrade.v1beta1.Upgrade.Plan getPlan() {
        if (planBuilder_ == null) {
          return plan_ == null ? cosmos.upgrade.v1beta1.Upgrade.Plan.getDefaultInstance() : plan_;
        } else {
          return planBuilder_.getMessage();
        }
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public Builder setPlan(cosmos.upgrade.v1beta1.Upgrade.Plan value) {
        if (planBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          plan_ = value;
          onChanged();
        } else {
          planBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public Builder setPlan(
          cosmos.upgrade.v1beta1.Upgrade.Plan.Builder builderForValue) {
        if (planBuilder_ == null) {
          plan_ = builderForValue.build();
          onChanged();
        } else {
          planBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public Builder mergePlan(cosmos.upgrade.v1beta1.Upgrade.Plan value) {
        if (planBuilder_ == null) {
          if (plan_ != null) {
            plan_ =
              cosmos.upgrade.v1beta1.Upgrade.Plan.newBuilder(plan_).mergeFrom(value).buildPartial();
          } else {
            plan_ = value;
          }
          onChanged();
        } else {
          planBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public Builder clearPlan() {
        if (planBuilder_ == null) {
          plan_ = null;
          onChanged();
        } else {
          plan_ = null;
          planBuilder_ = null;
        }

        return this;
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public cosmos.upgrade.v1beta1.Upgrade.Plan.Builder getPlanBuilder() {
        
        onChanged();
        return getPlanFieldBuilder().getBuilder();
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      public cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder getPlanOrBuilder() {
        if (planBuilder_ != null) {
          return planBuilder_.getMessageOrBuilder();
        } else {
          return plan_ == null ?
              cosmos.upgrade.v1beta1.Upgrade.Plan.getDefaultInstance() : plan_;
        }
      }
      /**
       * <code>.cosmos.upgrade.v1beta1.Plan plan = 3 [(.gogoproto.nullable) = false];</code>
       */
      private com.google.protobuf.SingleFieldBuilderV3<
          cosmos.upgrade.v1beta1.Upgrade.Plan, cosmos.upgrade.v1beta1.Upgrade.Plan.Builder, cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder> 
          getPlanFieldBuilder() {
        if (planBuilder_ == null) {
          planBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
              cosmos.upgrade.v1beta1.Upgrade.Plan, cosmos.upgrade.v1beta1.Upgrade.Plan.Builder, cosmos.upgrade.v1beta1.Upgrade.PlanOrBuilder>(
                  getPlan(),
                  getParentForChildren(),
                  isClean());
          plan_ = null;
        }
        return planBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:cosmos.upgrade.v1beta1.SoftwareUpgradeProposal)
    }

    // @@protoc_insertion_point(class_scope:cosmos.upgrade.v1beta1.SoftwareUpgradeProposal)
    private static final cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal();
    }

    public static cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<SoftwareUpgradeProposal>
        PARSER = new com.google.protobuf.AbstractParser<SoftwareUpgradeProposal>() {
      @java.lang.Override
      public SoftwareUpgradeProposal parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new SoftwareUpgradeProposal(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<SoftwareUpgradeProposal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<SoftwareUpgradeProposal> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public cosmos.upgrade.v1beta1.Upgrade.SoftwareUpgradeProposal getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface CancelSoftwareUpgradeProposalOrBuilder extends
      // @@protoc_insertion_point(interface_extends:cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <code>string title = 1;</code>
     * @return The title.
     */
    java.lang.String getTitle();
    /**
     * <code>string title = 1;</code>
     * @return The bytes for title.
     */
    com.google.protobuf.ByteString
        getTitleBytes();

    /**
     * <code>string description = 2;</code>
     * @return The description.
     */
    java.lang.String getDescription();
    /**
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    com.google.protobuf.ByteString
        getDescriptionBytes();
  }
  /**
   * <pre>
   * CancelSoftwareUpgradeProposal is a gov Content type for cancelling a software
   * upgrade.
   * </pre>
   *
   * Protobuf type {@code cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal}
   */
  public static final class CancelSoftwareUpgradeProposal extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal)
      CancelSoftwareUpgradeProposalOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use CancelSoftwareUpgradeProposal.newBuilder() to construct.
    private CancelSoftwareUpgradeProposal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private CancelSoftwareUpgradeProposal() {
      title_ = "";
      description_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new CancelSoftwareUpgradeProposal();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private CancelSoftwareUpgradeProposal(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              java.lang.String s = input.readStringRequireUtf8();

              title_ = s;
              break;
            }
            case 18: {
              java.lang.String s = input.readStringRequireUtf8();

              description_ = s;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.class, cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.Builder.class);
    }

    public static final int TITLE_FIELD_NUMBER = 1;
    private volatile java.lang.Object title_;
    /**
     * <code>string title = 1;</code>
     * @return The title.
     */
    @java.lang.Override
    public java.lang.String getTitle() {
      java.lang.Object ref = title_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        title_ = s;
        return s;
      }
    }
    /**
     * <code>string title = 1;</code>
     * @return The bytes for title.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getTitleBytes() {
      java.lang.Object ref = title_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        title_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    public static final int DESCRIPTION_FIELD_NUMBER = 2;
    private volatile java.lang.Object description_;
    /**
     * <code>string description = 2;</code>
     * @return The description.
     */
    @java.lang.Override
    public java.lang.String getDescription() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        description_ = s;
        return s;
      }
    }
    /**
     * <code>string description = 2;</code>
     * @return The bytes for description.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
        getDescriptionBytes() {
      java.lang.Object ref = description_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        description_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (!getTitleBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, title_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, description_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getTitleBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, title_);
      }
      if (!getDescriptionBytes().isEmpty()) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, description_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal)) {
        return super.equals(obj);
      }
      cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal other = (cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal) obj;

      if (!getTitle()
          .equals(other.getTitle())) return false;
      if (!getDescription()
          .equals(other.getDescription())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + TITLE_FIELD_NUMBER;
      hash = (53 * hash) + getTitle().hashCode();
      hash = (37 * hash) + DESCRIPTION_FIELD_NUMBER;
      hash = (53 * hash) + getDescription().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * CancelSoftwareUpgradeProposal is a gov Content type for cancelling a software
     * upgrade.
     * </pre>
     *
     * Protobuf type {@code cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal)
        cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposalOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.class, cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.Builder.class);
      }

      // Construct using cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        title_ = "";

        description_ = "";

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return cosmos.upgrade.v1beta1.Upgrade.internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal getDefaultInstanceForType() {
        return cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.getDefaultInstance();
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal build() {
        cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal buildPartial() {
        cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal result = new cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal(this);
        result.title_ = title_;
        result.description_ = description_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal) {
          return mergeFrom((cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal other) {
        if (other == cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal.getDefaultInstance()) return this;
        if (!other.getTitle().isEmpty()) {
          title_ = other.title_;
          onChanged();
        }
        if (!other.getDescription().isEmpty()) {
          description_ = other.description_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object title_ = "";
      /**
       * <code>string title = 1;</code>
       * @return The title.
       */
      public java.lang.String getTitle() {
        java.lang.Object ref = title_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          title_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string title = 1;</code>
       * @return The bytes for title.
       */
      public com.google.protobuf.ByteString
          getTitleBytes() {
        java.lang.Object ref = title_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          title_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string title = 1;</code>
       * @param value The title to set.
       * @return This builder for chaining.
       */
      public Builder setTitle(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        title_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string title = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearTitle() {
        
        title_ = getDefaultInstance().getTitle();
        onChanged();
        return this;
      }
      /**
       * <code>string title = 1;</code>
       * @param value The bytes for title to set.
       * @return This builder for chaining.
       */
      public Builder setTitleBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        title_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object description_ = "";
      /**
       * <code>string description = 2;</code>
       * @return The description.
       */
      public java.lang.String getDescription() {
        java.lang.Object ref = description_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs =
              (com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          description_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>string description = 2;</code>
       * @return The bytes for description.
       */
      public com.google.protobuf.ByteString
          getDescriptionBytes() {
        java.lang.Object ref = description_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          description_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>string description = 2;</code>
       * @param value The description to set.
       * @return This builder for chaining.
       */
      public Builder setDescription(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  
        description_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>string description = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearDescription() {
        
        description_ = getDefaultInstance().getDescription();
        onChanged();
        return this;
      }
      /**
       * <code>string description = 2;</code>
       * @param value The bytes for description to set.
       * @return This builder for chaining.
       */
      public Builder setDescriptionBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
        
        description_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal)
    }

    // @@protoc_insertion_point(class_scope:cosmos.upgrade.v1beta1.CancelSoftwareUpgradeProposal)
    private static final cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal();
    }

    public static cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<CancelSoftwareUpgradeProposal>
        PARSER = new com.google.protobuf.AbstractParser<CancelSoftwareUpgradeProposal>() {
      @java.lang.Override
      public CancelSoftwareUpgradeProposal parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new CancelSoftwareUpgradeProposal(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<CancelSoftwareUpgradeProposal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<CancelSoftwareUpgradeProposal> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public cosmos.upgrade.v1beta1.Upgrade.CancelSoftwareUpgradeProposal getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_cosmos_upgrade_v1beta1_Plan_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_cosmos_upgrade_v1beta1_Plan_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_fieldAccessorTable;
  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n$cosmos/upgrade/v1beta1/upgrade.proto\022\026" +
      "cosmos.upgrade.v1beta1\032\032google/protobuf2" +
      "/any.proto\032\024gogoproto/gogo.proto\032\037google" +
      "/protobuf/timestamp.proto\"\304\001\n\004Plan\022\014\n\004na" +
      "me\030\001 \001(\t\0222\n\004time\030\002 \001(\0132\032.google.protobuf" +
      ".TimestampB\010\220\337\037\001\310\336\037\000\022\016\n\006height\030\003 \001(\003\022\014\n\004" +
      "info\030\004 \001(\t\022V\n\025upgraded_client_state\030\005 \001(" +
      "\0132\025.google.protobuf2.AnyB \362\336\037\034yaml:\"upgr" +
      "aded_client_state\":\004\350\240\037\001\"u\n\027SoftwareUpgr" +
      "adeProposal\022\r\n\005title\030\001 \001(\t\022\023\n\013descriptio" +
      "n\030\002 \001(\t\0220\n\004plan\030\003 \001(\0132\034.cosmos.upgrade.v" +
      "1beta1.PlanB\004\310\336\037\000:\004\350\240\037\001\"I\n\035CancelSoftwar" +
      "eUpgradeProposal\022\r\n\005title\030\001 \001(\t\022\023\n\013descr" +
      "iption\030\002 \001(\t:\004\350\240\037\001B6Z,github.com/cosmos/" +
      "cosmos-sdk/x/upgrade/types\330\341\036\000\310\341\036\000b\006prot" +
      "o3"
    };
    descriptor = com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
          com.google.protobuf2.AnyProto.getDescriptor(),
          com.google.protobuf2.GoGoProtos.getDescriptor(),
          com.google.protobuf.TimestampProto.getDescriptor(),
        });
    internal_static_cosmos_upgrade_v1beta1_Plan_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_cosmos_upgrade_v1beta1_Plan_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_cosmos_upgrade_v1beta1_Plan_descriptor,
        new java.lang.String[] { "Name", "Time", "Height", "Info", "UpgradedClientState", });
    internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor =
      getDescriptor().getMessageTypes().get(1);
    internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_cosmos_upgrade_v1beta1_SoftwareUpgradeProposal_descriptor,
        new java.lang.String[] { "Title", "Description", "Plan", });
    internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor =
      getDescriptor().getMessageTypes().get(2);
    internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_cosmos_upgrade_v1beta1_CancelSoftwareUpgradeProposal_descriptor,
        new java.lang.String[] { "Title", "Description", });
    com.google.protobuf.ExtensionRegistry registry =
        com.google.protobuf.ExtensionRegistry.newInstance();
    registry.add(com.google.protobuf2.GoGoProtos.equal);
    registry.add(com.google.protobuf2.GoGoProtos.goprotoGettersAll);
    registry.add(com.google.protobuf2.GoGoProtos.goprotoStringerAll);
    registry.add(com.google.protobuf2.GoGoProtos.moretags);
    registry.add(com.google.protobuf2.GoGoProtos.nullable);
    registry.add(com.google.protobuf2.GoGoProtos.stdtime);
    com.google.protobuf.Descriptors.FileDescriptor
        .internalUpdateFileDescriptor(descriptor, registry);
    com.google.protobuf2.AnyProto.getDescriptor();
    com.google.protobuf2.GoGoProtos.getDescriptor();
    com.google.protobuf.TimestampProto.getDescriptor();
  }

  // @@protoc_insertion_point(outer_class_scope)
}
